#version 330

const int MAX_CLIP_PLANES = 6;

layout(location = 0) in uint objectId;
// WARNING: location must be 2 to make all scene shaders interchangable
layout(location = 2) in vec3 position;
layout(location = 3) in vec4 color;

out VertexData {
    flat uint objectId;
    vec4 color;
} outData;

layout(std140) uniform GlobalMatrices {
    mat4 vp;
    mat4 model;
    mat4 proj;
    mat4 view;
};

uniform vec3 plane[MAX_CLIP_PLANES];
uniform vec3 planeOrigin[MAX_CLIP_PLANES];

void clip()
{
    for (int i = 0; i < MAX_CLIP_PLANES; i++)
    {
        gl_ClipDistance[i] = dot(plane[i], position - planeOrigin[i]);
    }
}

void main() {
    outData.objectId = objectId;
    outData.color = color;

    clip();
    gl_Position = vp * model * vec4(position, 1.0);
}
